Subject: Re: bug#9594: 27.3 Numeric modes (File permissions): Special mode bits assume file is regular

From: Filipus Klutiero <[email-masked]>
Date: Sun, 25 Sep 2011 09:57:15 -0400

Le 2011-09-25 00:11, Paul Eggert a écrit :
> On 09/24/11 14:33, Filipus Klutiero wrote:
>
>> These correspondences assume that the file is a regular file.
> Not really: for example, the phrase "execute/search"
> refers to execution (for regular files) and search
> (for directories), and "Restricted deletion flag or sticky bit"
> is talking about directories (for deletion) and regular
> files (for sticky bit).
Sorry if the body didn't specify, but I was only referring to special 
mode bits. And indeed, one of them is OK.
> The phrase "Set group ID on execution" is not wrong, either,
> as it is saying that if you execute the file, then you set
> the group ID.  This phrase is used with the same meaning in
> the table in
>
> http://pubs.opengroup.org/onlinepubs/9699919799/basedefs/sys_stat.h.html
It may not be wrong, but it's misleading. On a directory, S_ISGID does 
not mean to set the group ID on execution. The meaning is OS-dependent.
> In such a small table, one can't explain *everything*.  Since
> the very next section talks about setuid and setgid on directories,
> the topic seems to be fairly well covered already.
Note that the manual is read by section, not sequentially. For example, 
I was reading 13.3 chmod and followed the link to 27.3.

It may be better to have 2 tables, or a table of common meanings and 2 
tables of specific meanings. I believe I would go for 2 tables.
>    However, if
> you have a specific suggestion for improving the wording while
> staying within the tight bounds established by the table, then
> that would help.
If kept in a single table, the wording should clarify that it only 
applies to regular files. It would be good to mention that the meaning 
on directories is OS-dependent, or to link to 27.4.